package net.provision.soap;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.FontMetrics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.KeyboardFocusManager;
import java.awt.Toolkit;
import java.awt.event.*;

import java.util.*;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.table.*;


//import com.jgoodies.plaf.HeaderStyle;
//import com.jgoodies.plaf.Options;
public class PrayerLog extends JFrame implements ListSelectionListener {
   Container c = getContentPane();
   DateButton dateBTN = new DateButton(new Date(), this);
   DefaultTableModel prayerTableMDL = new DefaultTableModel(3, 3);
   FlowLayout buttonLayout = new FlowLayout();
   GridBagConstraints gb;
   JButton cancelBTN;
   JButton deleteBTN;
   JButton editBTN;
   JButton newBTN;
   JButton saveBTN;
   JPanel buttonPNL = new JPanel(buttonLayout);
   JScrollPane prayerTableSP;
   JTable prayerTBL = new JTable();
   JTextArea answerTXA = new JTextArea(7, 20);
   JTextArea prayerTXA = new JTextArea(7, 20);
   ListSelectionModel rowSM;
   Storage storage;
   TableSorter prayerTableSorter;
   Vector data = new Vector();
   private boolean newEdit;
   private int currentItemLocation;
   private int selectedRow;

   public PrayerLog(Storage s) {
      this.storage = s;
      data = storage.getPLData();

      //display items from vector (data) in table
      Vector tableData = new Vector();

      for(int i = 0; i < data.size(); i++) {
         Vector row = new Vector();
         PrayerItem tmpItem = (PrayerItem)data.get(i);
         row.add(tmpItem.getDate());
         row.add(tmpItem.getPrayer());
         row.add(tmpItem.getAnswer());
         tableData.add(row);
      }

      //display column names
      Vector columnNames = new Vector();
      columnNames.add("Date");
      columnNames.add("Prayer");
      columnNames.add("Answer");

      prayerTableMDL = new DefaultTableModel(data, columnNames) {
               public boolean isCellEditable(int row, int column) {
                  return false;
               }
            };

      prayerTableSorter = new TableSorter(prayerTableMDL);

      Vector v = new Vector();
      v.add("Brett");
      v.add("One");
      v.add("two");
      prayerTableMDL.addRow(v);
      prayerTBL = new JTable(prayerTableSorter) {
               // Override this method so that it returns the preferred
               // size of the JTable instead of the default fixed size
               public Dimension getPreferredScrollableViewportSize() {
                  return getPreferredSize();
               }
            };

      prayerTableSorter.setTableHeader(prayerTBL.getTableHeader());
      prayerTableSorter.setSortingStatus(0, TableSorter.DESCENDING);
      prayerTBL.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      prayerTBL.setAlignmentX(JTable.CENTER_ALIGNMENT);
      prayerTBL.getTableHeader().setReorderingAllowed(false);

      //set the width for the date column
      TableColumnModel colModel = prayerTBL.getColumnModel();
      FontMetrics fm = getFontMetrics(prayerTBL.getFont());
      int dateWidth = fm.stringWidth("00/00/000000");
      colModel.getColumn(0).setMaxWidth(dateWidth);
      colModel.getColumn(0).setMinWidth(dateWidth);
      colModel.getColumn(0).setPreferredWidth(dateWidth);

      //remove border around selected cell
      UIManager.put("Table.focusCellHighlightBorder", new EmptyBorder(1, 1, 1, 1));

      //set the formatting for the "Date" column with DateRenderer and center
      //align all columns
      DateRenderer dateRenderer = new DateRenderer();
      dateRenderer.setHorizontalAlignment(SwingConstants.CENTER);

      //prayerTBL.getColumn("Date").setCellRenderer(dateRenderer);
      DefaultTableCellRenderer dtcr = new DefaultTableCellRenderer();
      dtcr.setHorizontalAlignment(SwingConstants.CENTER);

      //prayerTBL.getColumn("Prayer").setCellRenderer(dtcr);
      //prayerTBL.getColumn("Answer").setCellRenderer(dtcr);
      rowSM = prayerTBL.getSelectionModel();
      rowSM.addListSelectionListener(this);

      if(prayerTBL.getRowCount() > 0) {
         rowSM.setSelectionInterval(0, 0);
      }

      prayerTableSP = new JScrollPane(prayerTBL);
      prayerTableSP.setBorder(BorderFactory.createEmptyBorder());

      buttonLayout.setHgap(20);

      c.setLayout(new GridBagLayout());

      saveBTN = new JButton("Save");
      cancelBTN = new JButton("Cancel");
      editBTN = new JButton("Edit");
      deleteBTN = new JButton("Delete");
      newBTN = new JButton("New");

      newBTN.setFocusPainted(false);
      editBTN.setFocusPainted(false);
      deleteBTN.setFocusPainted(false);

      //      saveBTN.setFont(SOAPGUI.BUTTON_FONT);
      //      cancelBTN.setFont(SOAPGUI.BUTTON_FONT);
      //      saveBTN.setBorder(SOAPGUI.BUTTON_BORDER);
      //      cancelBTN.setBorder(SOAPGUI.BUTTON_BORDER);
      buttonPNL.add(saveBTN);
      buttonPNL.add(cancelBTN);

      JToolBar toolbar = new JToolBar();

      //toolbar.putClientProperty(Options.HEADER_STYLE_KEY, HeaderStyle.BOTH);
      toolbar.setBorderPainted(true);
      toolbar.setBorder(BorderFactory.createEtchedBorder());
      toolbar.setRollover(true);
      toolbar.setFloatable(false);

      toolbar.add(newBTN);
      toolbar.add(editBTN);
      toolbar.add(deleteBTN);

      //      prayerTXA.setFont(SOAPGUI.DEFAULT_FONT);
      prayerTXA.setLineWrap(true);
      prayerTXA.setWrapStyleWord(true);

      //      prayerTXA.setMargin(SOAPGUI.TEXT_INS);
      //      answerTXA.setFont(SOAPGUI.DEFAULT_FONT);
      answerTXA.setLineWrap(true);
      answerTXA.setWrapStyleWord(true);

      //      answerTXA.setMargin(SOAPGUI.TEXT_INS);
      JScrollPane prayerSP = new JScrollPane(prayerTXA);
      JScrollPane answerSP = new JScrollPane(answerTXA);

      //      prayerSP.setBorder(SOAPGUI.BLACK_LINE_BORDER);
      //      answerSP.setBorder(SOAPGUI.BLACK_LINE_BORDER);
      newBTN.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               prayerTXA.setText("");
               answerTXA.setText("");
               dateBTN.setDate(new Date());
               newEdit = true;
               edit(true);
            }
         });

      editBTN.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               newEdit = false;
               edit(true);
            }
         });

      deleteBTN.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            }
         });

      saveBTN.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               Date date = dateBTN.getDate();
               String prayer = prayerTXA.getText();
               String answer = answerTXA.getText();
               PrayerItem item = new PrayerItem(date, prayer, answer);

               //trying to add an item that has already been added.
               if((data.indexOf(item) != -1) && newEdit) {
                  JOptionPane.showMessageDialog(PrayerLog.this,
                     "Duplicate Record: A new record cannot be \n" +
                     "added that contains the same date, title, \n" +
                     "and topic as an existing entry. \n\n" +
                     "Please change one of these values in order \n" +
                     "to add the entry.");
               } else if(newEdit) {
                  data.add(item);

                  //add item to row in table
                  Vector tempVector = new Vector();
                  tempVector.add(date);
                  tempVector.add(prayer);
                  tempVector.add(answer);
                  prayerTableMDL.addRow(tempVector);

                  int row = prayerTableMDL.getRowCount() - 1;
                  rowSM.setSelectionInterval(row, row);
               } else {
                  //update item in vector
                  data.setElementAt(item, currentItemLocation);

                  //update item in table
                  prayerTableSorter.setValueAt(date, selectedRow, 0);
                  prayerTableSorter.setValueAt(prayer, selectedRow, 1);
                  prayerTableSorter.setValueAt(answer, selectedRow, 2);
                  prayerTableSorter.fireTableDataChanged();

                  //reselect the row the user just edited.
                  rowSM.setSelectionInterval(selectedRow, selectedRow);
               }

               edit(false);
            }
         });

      cancelBTN.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               edit(false);
            }
         });

      gb = new GridBagConstraints();

      gb.gridx = 0;
      gb.gridy = 0;
      gb.gridwidth = 2;
      gb.fill = GridBagConstraints.HORIZONTAL;
      c.add(toolbar, gb);

      gb.gridx = 0;
      gb.gridy = 1;
      gb.gridwidth = 2;
      c.add(prayerTableSP, gb);

      gb.gridx = 0;
      gb.gridy = 2;
      gb.gridwidth = 1;
      gb.insets = new Insets(10, 20, 0, 20);
      c.add(new JLabel("Date:"), gb);

      gb.gridx = 1;
      gb.insets = new Insets(10, 0, 10, 20);
      c.add(dateBTN, gb);

      gb.gridx = 0;
      gb.gridy = 3;
      gb.insets = new Insets(10, 20, 0, 20);
      c.add(new JLabel("Prayer:"), gb);

      gb.gridx = 1;
      gb.insets = new Insets(10, 0, 10, 20);
      c.add(prayerSP, gb);

      gb.gridx = 0;
      gb.gridy = 4;
      gb.insets = new Insets(10, 20, 0, 20);
      c.add(new JLabel("Answer:"), gb);

      gb.gridx = 1;
      gb.insets = new Insets(10, 0, 10, 20);
      c.add(answerSP, gb);

      pack();

      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      int y = (d.height / 2) - (getHeight() / 2);
      setLocation((d.width / 2) - (getWidth() / 2), y);
      setTitle("SOAP - created by Brett Batie");
      setDefaultCloseOperation(DISPOSE_ON_CLOSE);
      setResizable(false);
      setVisible(true);

      addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
               try {
                  //update data in storage and write to file.
                  storage.setPLData(data);
               } catch(Exception e) {
                  JOptionPane.showMessageDialog(PrayerLog.this,
                     "Could not access the " +
                     "database! Make sure the database exist and has read/write " +
                     "permission.");
               }
            }
         });

      edit(false);
   } //end of constructor

   /**
    * DOCUMENT ME!
    *
    * @param edit DOCUMENT ME!
    */
   public void edit(boolean edit) {
      if(edit) {
         answerTXA.setEnabled(true);
         prayerTXA.setEnabled(true);

         //            answerTXA.setBackground(SOAPGUI.TEXT_BACKGROUND);
         //            prayerTXA.setBackground(SOAPGUI.TEXT_BACKGROUND);
         dateBTN.setBorder(BorderFactory.createRaisedBevelBorder());
         dateBTN.setFocusable(true);
         dateBTN.setButtonState(true);
         c.remove(prayerTableSP);
         pack();
         c.repaint();
         newBTN.setEnabled(false);
         editBTN.setEnabled(false);
         deleteBTN.setEnabled(false);

         //display save and cancel buttons
         gb.gridx = 0;
         gb.gridy = 5;
         gb.gridwidth = 2;
         gb.weighty = 0;
         gb.weightx = 0;
         gb.insets = new Insets(10, 20, 10, 20);
         gb.anchor = GridBagConstraints.CENTER;
         gb.fill = GridBagConstraints.BOTH;
         c.add(buttonPNL, gb);
         pack();

         //make tab go to next focusable item for textareas and jtable
         Set forwardTraversalKeys = new TreeSet();
         forwardTraversalKeys.add(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, 0));

         Set backwardTraversalKeys = new TreeSet();
         backwardTraversalKeys.add(KeyStroke.getKeyStroke(KeyEvent.VK_TAB,
               InputEvent.SHIFT_MASK));
         answerTXA.setFocusTraversalKeys(KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS,
            forwardTraversalKeys);
         answerTXA.setFocusTraversalKeys(KeyboardFocusManager.BACKWARD_TRAVERSAL_KEYS,
            backwardTraversalKeys);
         prayerTXA.setFocusTraversalKeys(KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS,
            forwardTraversalKeys);
         prayerTXA.setFocusTraversalKeys(KeyboardFocusManager.BACKWARD_TRAVERSAL_KEYS,
            backwardTraversalKeys);

         answerTXA.addKeyListener(new TextAreaTab());
         prayerTXA.addKeyListener(new TextAreaTab());
      } else {
         answerTXA.setEnabled(false);
         prayerTXA.setEnabled(false);
         answerTXA.setBackground(super.getBackground());
         prayerTXA.setBackground(super.getBackground());
         dateBTN.setBackground(super.getBackground());
         dateBTN.setFocusable(true);
         dateBTN.setButtonState(true);
         newBTN.setEnabled(true);
         editBTN.setEnabled(true);
         deleteBTN.setEnabled(true);

         if(data.isEmpty()) {
            editBTN.setEnabled(false);
            deleteBTN.setEnabled(false);
         } else {
            editBTN.setEnabled(true);
            deleteBTN.setEnabled(true);
         }

         //add the table back
         gb.gridx = 0;
         gb.gridy = 1;
         gb.gridwidth = 2;
         c.add(prayerTableSP, gb);

         //remove save and cancel buttons
         c.remove(buttonPNL);
         pack();
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @param e DOCUMENT ME!
    */
   public void valueChanged(ListSelectionEvent e) {
      //Ignore extra message
      if(e.getValueIsAdjusting() || (prayerTBL.getSelectedRow() == -1)) {
         return;
      }

      //update selected row
      selectedRow = prayerTBL.getSelectedRow();

      //        if (selectedRow == -1) {
      //            return;
      //        }
      //I think the below is what updates all the values in the non-editable display
      //      Object[] obj = new Object[prayerTBL.getColumnCount()];
      //
      //      for(int column = 0; (column < obj.length) && (selectedRow != -1); column++) {
      //         obj[column] = prayerTBL.getValueAt(selectedRow, column);
      //      }
      //
      //      PrayerItem tempItem = new PrayerItem((Date)obj[0], (String)obj[1], (String)obj[2]);
      //
      //      currentItemLocation = data.indexOf(tempItem);
      //
      //      if(currentItemLocation != -1) {
      //         //            currentItem = (DailyItem) dailyItems.elementAt(currentItemLocation);
      //         //            verseTopicTXF.setText(currentItem.getTopic());
      //         //            dateBTN.setDate(currentItem.getDate());
      //         //            titleTXF.setText(currentItem.getTitle());
      //         //            scriptureTXA.setText(currentItem.getScripture());
      //         //            observationTXA.setText(currentItem.getObservation());
      //         //            applicationTXA.setText(currentItem.getApplication());
      //         //            prayerTXA.setText(currentItem.getPrayer());
      //      }
   }
}
