package net.provision.soap;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.KeyboardFocusManager;
import java.awt.Toolkit;
import java.awt.event.*;

import java.util.*;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.table.*;


/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
 */
public class SOAPGUI extends JFrame implements ListSelectionListener {
   public static final Font SUB_TITLE_FONT = new Font("Monospaced", Font.BOLD, 16);
   public static final Font TITLE_FONT = new Font("Serif", Font.BOLD, 20);
   public static final Font BUTTON_FONT = new Font("Dialog", Font.BOLD, 16);
   public static final Font DEFAULT_FONT = new Font("Monospaced", Font.PLAIN, 14);
   static Border BLACK_LINE_BORDER = BorderFactory.createLineBorder(Color.BLACK);
   public static Border BUTTON_BORDER = new CompoundBorder(BorderFactory.createLineBorder(
            Color.BLACK), new EmptyBorder(5, 10, 5, 10));
   public static Insets TEXT_INS = new Insets(5, 5, 5, 5);
   private static boolean newEdit;
   public static int dateButttonX;
   public static int dateButtonY;
   public static Color TEXT_BACKGROUND = Color.WHITE;
   DefaultTableModel tableMDL;
   FlowLayout buttonLayout = new FlowLayout();
   JPanel buttonPNL = new JPanel(buttonLayout);
   TableSorter sorter;
   private final Border blackLineSpaceBDR;
   private Action aboutACT;
   private Action aboutMenuACT;
   private Action dailyReadingACT;
   private Action dailyReadingMenuACT;
   private Action deleteACT;
   private Action deleteMenuACT;
   private Action editACT;
   private Action editMenuACT;
   private Action exitACT;
   private Action exitMenuACT;
   private Action newACT;
   private Action newMenuACT;
   private Action prayerLogACT;
   private Action prayerLogMenuACT;
   private Color background = new Color(152, 152, 152);
   private Container c = getContentPane();
   private DailyItem currentItem;
   private DateButton dateBTN;
   private GridBagConstraints gb = new GridBagConstraints();
   private JButton aboutBTN;
   private JButton cancelBTN;
   private JButton dailyReadingBTN;
   private JButton deleteBTN;
   private JButton editBTN;
   private JButton exitBTN;
   private JButton newBTN;
   private JButton prayerLogBTN;
   private JButton saveBTN;
   private JMenuItem aboutMNI;
   private JMenuItem dailyReadingMNI;
   private JMenuItem deleteMNI;
   private JMenuItem editMNI;
   private JMenuItem exitMNI;
   private JMenuItem newEntryMNI;
   private JMenuItem prayerLogMNI;
   private JScrollPane applicationSP;
   private JScrollPane dailyItemsSP;
   private JScrollPane observationSP;
   private JScrollPane prayerSP;
   private JScrollPane scriptureSP;
   private JTable dailyItemsTBL;
   private JTextArea applicationTXA;
   private JTextArea observationTXA;
   private JTextArea prayerTXA;
   private JTextArea scriptureTXA;
   private JTextField titleTXF;
   private JTextField verseTopicTXF;
   private ListSelectionModel rowSM;
   private Storage storage;
   private Vector dailyItems;
   private int currentItemLocation;
   private int selectedRow;

   public SOAPGUI() {
      dateBTN = new DateButton(new Date(), this);
      buttonLayout.setHgap(20);

      //create components
      saveBTN = new JButton("Save");
      cancelBTN = new JButton("Cancel");
      verseTopicTXF = new JTextField(20);
      titleTXF = new JTextField("");
      scriptureTXA = new JTextArea(7, 20);
      observationTXA = new JTextArea(7, 20);
      applicationTXA = new JTextArea(7, 20);
      prayerTXA = new JTextArea(7, 20);
      scriptureSP = new JScrollPane(scriptureTXA);
      observationSP = new JScrollPane(observationTXA);
      applicationSP = new JScrollPane(applicationTXA);
      prayerSP = new JScrollPane(prayerTXA);

      JLabel scriptureLBL = new JLabel("<html><font size=5 color=#9D1009>S" +
            "</font>cripture:</html>");
      JLabel observationLBL = new JLabel("<html><font size=5 color=#9D1009>" +
            "O</font>bservation:</html>");
      JLabel applicationLBL = new JLabel("<html><font size=5 color=#9D1009>" +
            "A</font>pplication</html>:");
      JLabel prayerLBL = new JLabel("<html><font size=5 color=#9D1009>P" +
            "</font>rayer</html>:");

      //borders
      blackLineSpaceBDR = new CompoundBorder(BorderFactory.createLineBorder(Color.BLACK),
            new EmptyBorder(0, 5, 0, 5));
      scriptureSP.setBorder(BLACK_LINE_BORDER);
      observationSP.setBorder(BLACK_LINE_BORDER);
      applicationSP.setBorder(BLACK_LINE_BORDER);
      prayerSP.setBorder(BLACK_LINE_BORDER);

      //setup components
      //      scriptureLBL.setBorder(new EmptyBorder(0, 0, 0, 0));
      //      observationLBL.setBorder(new EmptyBorder(0, 0, 0, 0));
      //      applicationLBL.setBorder(new EmptyBorder(0, 0, 0, 0));
      //      prayerLBL.setBorder(new EmptyBorder(0, 0, 0, 0));
      titleTXF.setFont(TITLE_FONT);
      verseTopicTXF.setFont(DEFAULT_FONT);
      scriptureTXA.setFont(DEFAULT_FONT);
      observationTXA.setFont(DEFAULT_FONT);
      applicationTXA.setFont(DEFAULT_FONT);
      scriptureLBL.setFont(SUB_TITLE_FONT);
      observationLBL.setFont(SUB_TITLE_FONT);
      applicationLBL.setFont(SUB_TITLE_FONT);
      prayerLBL.setFont(SUB_TITLE_FONT);
      prayerTXA.setFont(DEFAULT_FONT);

      scriptureTXA.setLineWrap(true);
      observationTXA.setLineWrap(true);
      applicationTXA.setLineWrap(true);
      prayerTXA.setLineWrap(true);
      scriptureTXA.setWrapStyleWord(true);
      observationTXA.setWrapStyleWord(true);
      applicationTXA.setWrapStyleWord(true);
      prayerTXA.setWrapStyleWord(true);

      titleTXF.setHorizontalAlignment(JTextField.CENTER);
      scriptureLBL.setVerticalAlignment(SwingConstants.BOTTOM);
      observationLBL.setVerticalAlignment(SwingConstants.BOTTOM);
      applicationLBL.setVerticalAlignment(SwingConstants.BOTTOM);
      prayerLBL.setVerticalAlignment(SwingConstants.BOTTOM);

      scriptureLBL.setFocusable(false);
      observationLBL.setFocusable(false);
      applicationLBL.setFocusable(false);
      prayerLBL.setFocusable(false);

      scriptureTXA.setMargin(TEXT_INS);
      observationTXA.setMargin(TEXT_INS);
      applicationTXA.setMargin(TEXT_INS);
      prayerTXA.setMargin(TEXT_INS);

      saveBTN.setFont(BUTTON_FONT);
      cancelBTN.setFont(BUTTON_FONT);

      saveBTN.setBorder(BUTTON_BORDER);
      cancelBTN.setBorder(BUTTON_BORDER);

      buttonPNL.add(saveBTN);
      buttonPNL.add(cancelBTN);

      createTable();

      //menu
      JMenuBar menuBar = new JMenuBar();

      JMenu fileMNU = new JMenu("File");
      fileMNU.setMnemonic('F');

      JMenu viewMNU = new JMenu("View");
      viewMNU.setMnemonic('V');

      JMenu helpMNU = new JMenu("Help");
      helpMNU.setMnemonic('H');

      newEntryMNI = new JMenuItem("New Entry");
      editMNI = new JMenuItem("Edit");
      deleteMNI = new JMenuItem("Delete");
      exitMNI = new JMenuItem("Exit");
      aboutMNI = new JMenuItem("About");
      dailyReadingMNI = new JMenuItem("Daily Reading");
      prayerLogMNI = new JMenuItem("Prayer Log");

      menuBar.add(fileMNU);
      menuBar.add(viewMNU);
      menuBar.add(helpMNU);
      fileMNU.add(newEntryMNI);
      fileMNU.add(editMNI);
      fileMNU.add(deleteMNI);
      fileMNU.add(exitMNI);
      viewMNU.add(dailyReadingMNI);

      //viewMNU.add(prayerLogMNI);
      helpMNU.add(aboutMNI);

      //initialize actions
      exitACT = new ExitAction("Exit", null, "Exit", new Integer(KeyEvent.VK_X));
      editACT = new EditAction("Edit", createGeneralIcon("edit22"), "Edit Entry",
            new Integer(KeyEvent.VK_E));
      editMenuACT = new EditAction("Edit", createGeneralIcon("edit16"), "Edit Entry",
            new Integer(KeyEvent.VK_E));
      newACT = new NewAction("New", createGeneralIcon("new22"), "Create New Entry",
            new Integer(KeyEvent.VK_N));
      newMenuACT = new NewAction("New", createGeneralIcon("new16"), "Create New Entry",
            new Integer(KeyEvent.VK_N));
      aboutACT = new AboutAction("About", createGeneralIcon("about22"),
            "Info About This Program", new Integer(KeyEvent.VK_B));
      aboutMenuACT = new AboutAction("About", createGeneralIcon("about16"),
            "Info About This Program", new Integer(KeyEvent.VK_B));
      deleteACT = new DeleteAction("Delete", createGeneralIcon("delete22"),
            "Delete Entry", new Integer(KeyEvent.VK_D));
      deleteMenuACT = new DeleteAction("Delete", createGeneralIcon("delete16"),
            "Delete Entry", new Integer(KeyEvent.VK_D));
      dailyReadingACT = new DailyReadingAction("Daily Reading",
            createGeneralIcon("dailyReading22"), "View Daily Readings",
            new Integer(KeyEvent.VK_R));
      dailyReadingMenuACT = new DailyReadingAction("Daily Reading",
            createGeneralIcon("dailyReading16"), "View Daily Readings",
            new Integer(KeyEvent.VK_R));

      //      prayerLogACT = new PrayerLogAction("Prayer Log",
      //            createGeneralIcon("AlignJustify22"), "Prayer Log",
      //            new Integer(KeyEvent.VK_P));
      //      prayerLogMenuACT = new PrayerLogAction("Prayer Log",
      //            createGeneralIcon("AlignJustify16"), "Prayer Log",
      //            new Integer(KeyEvent.VK_P));
      //Options.setDefaultIconSize(new Dimension(24,24));
      exitMNI.setAction(exitMenuACT);
      editMNI.setAction(editMenuACT);
      newEntryMNI.setAction(newMenuACT);
      aboutMNI.setAction(aboutMenuACT);
      deleteMNI.setAction(deleteMenuACT);
      dailyReadingMNI.setAction(dailyReadingMenuACT);
      prayerLogMNI.setAction(prayerLogMenuACT);

      JToolBar toolBar = new JToolBar();
      toolBar.setRollover(true);
      toolBar.setFloatable(false);

      newBTN = new JButton(newACT);
      newBTN.setFocusPainted(false);
      editBTN = new JButton(editACT);
      editBTN.setFocusPainted(false);
      dailyReadingBTN = new JButton(dailyReadingACT);
      dailyReadingBTN.setFocusPainted(false);
      prayerLogBTN = new JButton(prayerLogACT);
      prayerLogBTN.setFocusPainted(false);
      deleteBTN = new JButton(deleteACT);
      deleteBTN.setFocusPainted(false);
      aboutBTN = new JButton(aboutACT);
      aboutBTN.setFocusPainted(false);

      toolBar.add(newBTN);
      toolBar.add(editBTN);
      toolBar.add(dailyReadingBTN);

      //toolBar.add(prayerLogBTN);
      toolBar.add(deleteBTN);
      toolBar.add(aboutBTN);

      titleTXF.addFocusListener(new FocusListener() {
            public void focusGained(FocusEvent e) {
               titleTXF.selectAll();
            }

            public void focusLost(FocusEvent e) {
            }
         });

      saveBTN.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
               //add DailyItem object to Vector
               Date date = dateBTN.getDate();
               String verseTopic = verseTopicTXF.getText();
               String title = titleTXF.getText();
               String scripture = scriptureTXA.getText();
               String observation = observationTXA.getText();
               String application = applicationTXA.getText();
               String prayer = prayerTXA.getText();

               DailyItem item = new DailyItem(date, verseTopic, title, scripture,
                     observation, application, prayer);

               if((dailyItems.indexOf(item) != -1) && newEdit) {
                  JOptionPane.showMessageDialog(SOAPGUI.this,
                     "Duplicate Record: A new record cannot be \n" +
                     "added that contains the same date, title, \n" +
                     "and topic as an existing entry. \n\n" +
                     "Please change one of these values in order \n" +
                     "to add the entry.");
               } else if(newEdit) {
                  //add item to vector
                  dailyItems.add(item);

                  //add item to row in table
                  Vector tempVector = new Vector();
                  tempVector.add(date);
                  tempVector.add(verseTopic);
                  tempVector.add(title);
                  tableMDL.addRow(tempVector);

                  newEdit = false;
                  edit(false);

                  int row = tableMDL.getRowCount() - 1;
                  rowSM.setSelectionInterval(row, row);
               } else {
                  //update item in vector
                  dailyItems.setElementAt(item, currentItemLocation);

                  //update item in table
                  sorter.setValueAt(date, selectedRow, 0);
                  sorter.setValueAt(verseTopic, selectedRow, 1);
                  sorter.setValueAt(title, selectedRow, 2);
                  sorter.fireTableDataChanged();
                  edit(false);

                  //reselect the row the user just edited.
                  rowSM.setSelectionInterval(selectedRow, selectedRow);
               }
            }
         });

      cancelBTN.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
               edit(false);
            }
         });

      //layout components
      c.setLayout(new GridBagLayout());

      //c.setBackground(background);
      Insets textFieldINS = new Insets(0, 20, 5, 20);
      Insets labelINS = new Insets(0, 20, 1, 20);

      gb.gridx = 1;
      gb.gridy = 3;
      gb.weightx = 0;
      gb.insets = new Insets(10, 20, 5, 5); //top, left, bottom, right
      gb.fill = GridBagConstraints.HORIZONTAL;
      c.add(new JLabel("Verse / Topic:"), gb);

      gb.gridx = 2;
      gb.insets = new Insets(10, 0, 5, 10);
      gb.weightx = 100;
      c.add(verseTopicTXF, gb);

      gb.gridx = 3;
      gb.insets = new Insets(10, 10, 5, 5);
      gb.anchor = GridBagConstraints.EAST;
      gb.weightx = 0;
      c.add(new JLabel("Date:"), gb);

      gb.gridx = 4;
      gb.insets = new Insets(10, 20, 5, 20);
      gb.fill = GridBagConstraints.NONE;
      c.add(dateBTN, gb);

      gb.gridx = 1;
      gb.gridy = 1;
      gb.gridwidth = 4;
      gb.weightx = 100;
      gb.fill = GridBagConstraints.BOTH;
      gb.insets = new Insets(0, 0, 0, 0);
      c.add(toolBar, gb);

      gb.gridx = 1;
      gb.gridy = 4;
      gb.gridwidth = 4;
      gb.weighty = 0;
      gb.weightx = 100;
      gb.anchor = GridBagConstraints.CENTER;
      gb.fill = GridBagConstraints.BOTH;
      gb.insets = new Insets(0, 20, 0, 20);
      c.add(titleTXF, gb);

      gb.gridy = 5;
      gb.weighty = 0;
      gb.insets = labelINS;
      c.add(scriptureLBL, gb);

      gb.gridy = 6;
      gb.weighty = 100;
      gb.insets = textFieldINS;
      c.add(scriptureSP, gb);

      gb.gridy = 7;
      gb.weighty = 0;
      gb.insets = labelINS;
      c.add(observationLBL, gb);

      gb.gridy = 8;
      gb.weighty = 100;
      gb.insets = textFieldINS;
      c.add(observationSP, gb);

      gb.gridy = 9;
      gb.weighty = 0;
      gb.insets = labelINS;
      c.add(applicationLBL, gb);

      gb.gridy = 10;
      gb.weighty = 100;
      gb.insets = textFieldINS;
      c.add(applicationSP, gb);

      gb.gridy = 11;
      gb.weighty = 0;
      gb.insets = labelINS;
      c.add(prayerLBL, gb);

      gb.gridy = 12;
      gb.weighty = 100;
      gb.insets = new Insets(0, 20, 20, 20);
      c.add(prayerSP, gb);

      dailyItemsSP = new JScrollPane(dailyItemsTBL);
      dailyItemsSP.setBorder(BorderFactory.createEmptyBorder());

      edit(false);

      setJMenuBar(menuBar);
      setTitle("SOAP"); //FIXME: have it also display the version number
      pack();

      //insure frame is not larger than screensize and center
      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      int y = (d.height / 2) - (getHeight() / 2);
      int toolbarSize = 50; //FIXME: there has got to be a better way, its using the

      //toolbar size to ensure that the height isn't larger than the toolbar.
      //This is fine for most peope since they don't grow or move the toolbar. But,
      //still is a cheap way of handling this.
      if(getHeight() > (d.height - toolbarSize)) {
         setSize(getWidth(), d.height - toolbarSize);
         y = 0;
      }

      setLocation((d.width / 2) - (getWidth() / 2), y);
      setExtendedState(MAXIMIZED_BOTH);
      setDefaultCloseOperation(EXIT_ON_CLOSE);
      setVisible(true);

      addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
               try {
                  //update data in storage and write to file.
                  storage.setDIData(dailyItems);
                  storage.writeToFile();
               } catch(Exception e) {
                  JOptionPane.showMessageDialog(SOAPGUI.this,
                     "Could not " +
                     "access the database! Make sure the database exists" +
                     " and has read/write permission.");
               }
            }
         });
   } //end of constructor 

   /**
    * DOCUMENT ME!
    */
   public void createTable() {
      try {
         storage = new Storage();
         dailyItems = storage.getDIData();
      } catch(Exception e) {
         JOptionPane.showMessageDialog(this, "Could not access the " + "database!" + e);
         dailyItems = new Vector();
      }

      Vector tableData = new Vector();

      for(int i = 0; i < dailyItems.size(); i++) {
         Vector row = new Vector();
         DailyItem dailyItem = (DailyItem)dailyItems.get(i);
         row.add(dailyItem.getDate());
         row.add(dailyItem.getTopic());
         row.add(dailyItem.getTitle());
         tableData.add(row);
      }

      Vector columnNames = new Vector();
      columnNames.add("Date");
      columnNames.add("Scripture/Topic");
      columnNames.add("Title");

      tableMDL = new DefaultTableModel(3, 7);
      tableMDL = new DefaultTableModel(tableData, columnNames) {
               public boolean isCellEditable(int row, int column) {
                  return false;
               }
            };
      sorter = new TableSorter(tableMDL);
      dailyItemsTBL = new JTable(sorter) {
               // Override this method so that it returns the preferred
               // size of the JTable instead of the default fixed size
               public Dimension getPreferredScrollableViewportSize() {
                  return getPreferredSize();
               }
            };
      sorter.setTableHeader(dailyItemsTBL.getTableHeader());
      sorter.setSortingStatus(0, TableSorter.DESCENDING);
      dailyItemsTBL.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      dailyItemsTBL.setAlignmentX(JTable.CENTER_ALIGNMENT);
      dailyItemsTBL.getTableHeader().setReorderingAllowed(false);

      TableColumnModel colModel = dailyItemsTBL.getColumnModel();
      FontMetrics fm = getFontMetrics(dailyItemsTBL.getFont());
      int dateWidth = fm.stringWidth("00/00/000000");
      colModel.getColumn(0).setMaxWidth(dateWidth);
      colModel.getColumn(0).setMinWidth(dateWidth);
      colModel.getColumn(0).setPreferredWidth(dateWidth);

      //remove border around selected cell
      UIManager.put("Table.focusCellHighlightBorder", new EmptyBorder(1, 1, 1, 1));

      //set the formatting for the "Date" column with DateRenderer and center
      //align all columns
      DateRenderer dateRenderer = new DateRenderer();
      dateRenderer.setHorizontalAlignment(SwingConstants.CENTER);
      dailyItemsTBL.getColumn("Date").setCellRenderer(dateRenderer);

      DefaultTableCellRenderer dtcr = new DefaultTableCellRenderer();
      dtcr.setHorizontalAlignment(SwingConstants.CENTER);
      dailyItemsTBL.getColumn("Scripture/Topic").setCellRenderer(dtcr);
      dailyItemsTBL.getColumn("Title").setCellRenderer(dtcr);

      rowSM = dailyItemsTBL.getSelectionModel();
      rowSM.addListSelectionListener(this);

      if(dailyItemsTBL.getRowCount() > 0) {
         rowSM.setSelectionInterval(0, 0);
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @param edit DOCUMENT ME!
    */
   public void edit(boolean edit) {
      Color borderColor = Color.BLACK;

      if(edit) {
         //make components editable
         verseTopicTXF.setEditable(true);
         titleTXF.setEditable(true);
         verseTopicTXF.setBorder(blackLineSpaceBDR);
         titleTXF.setBorder(blackLineSpaceBDR);
         scriptureTXA.setEditable(true);
         observationTXA.setEditable(true);
         applicationTXA.setEditable(true);
         prayerTXA.setEditable(true);
         dateBTN.setBorder(BorderFactory.createRaisedBevelBorder());
         dateBTN.setFocusable(true);
         dateBTN.setButtonState(true);
         verseTopicTXF.setBackground(TEXT_BACKGROUND);
         titleTXF.setBackground(TEXT_BACKGROUND);
         dateBTN.setBackground(TEXT_BACKGROUND);
         scriptureTXA.setBackground(TEXT_BACKGROUND);
         observationTXA.setBackground(TEXT_BACKGROUND);
         applicationTXA.setBackground(TEXT_BACKGROUND);
         prayerTXA.setBackground(TEXT_BACKGROUND);

         //hide/remove
         c.remove(dailyItemsSP);
         c.repaint();
         editMNI.setEnabled(false);
         newEntryMNI.setEnabled(false);
         deleteMNI.setEnabled(false);
         dailyReadingBTN.setEnabled(true);
         prayerLogBTN.setEnabled(true);

         //exitMNI.setEnabled(false);
         editBTN.setEnabled(false);
         newBTN.setEnabled(false);
         deleteBTN.setEnabled(false);

         //display save & cancel buttons
         gb.gridy = 13;
         gb.gridx = 1;
         gb.gridwidth = 4;
         gb.weighty = 0;
         gb.weightx = 0;
         gb.insets = new Insets(10, 20, 10, 20);
         gb.anchor = GridBagConstraints.CENTER;
         gb.fill = GridBagConstraints.BOTH;
         c.add(buttonPNL, gb);

         //make tab go to next focusable item for textareas and jtable
         Set forwardTraversalKeys = new TreeSet();
         forwardTraversalKeys.add(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, 0));

         Set backwardTraversalKeys = new TreeSet();
         backwardTraversalKeys.add(KeyStroke.getKeyStroke(KeyEvent.VK_TAB,
               InputEvent.SHIFT_MASK));
         scriptureTXA.setFocusTraversalKeys(KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS,
            forwardTraversalKeys);
         scriptureTXA.setFocusTraversalKeys(KeyboardFocusManager.BACKWARD_TRAVERSAL_KEYS,
            backwardTraversalKeys);
         observationTXA.setFocusTraversalKeys(KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS,
            forwardTraversalKeys);
         observationTXA.setFocusTraversalKeys(KeyboardFocusManager.BACKWARD_TRAVERSAL_KEYS,
            backwardTraversalKeys);
         applicationTXA.setFocusTraversalKeys(KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS,
            forwardTraversalKeys);
         applicationTXA.setFocusTraversalKeys(KeyboardFocusManager.BACKWARD_TRAVERSAL_KEYS,
            backwardTraversalKeys);
         prayerTXA.setFocusTraversalKeys(KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS,
            forwardTraversalKeys);
         prayerTXA.setFocusTraversalKeys(KeyboardFocusManager.BACKWARD_TRAVERSAL_KEYS,
            backwardTraversalKeys);

         verseTopicTXF.requestFocus();

         scriptureTXA.addKeyListener(new TextAreaTab());
         observationTXA.addKeyListener(new TextAreaTab());
         applicationTXA.addKeyListener(new TextAreaTab());
         prayerTXA.addKeyListener(new TextAreaTab());
      } else {
         verseTopicTXF.setEditable(false);
         titleTXF.setEditable(false);
         scriptureTXA.setEditable(false);
         observationTXA.setEditable(false);
         applicationTXA.setEditable(false);
         prayerTXA.setEditable(false);
         verseTopicTXF.setBackground(super.getBackground());
         titleTXF.setBackground(super.getBackground());
         dateBTN.setBackground(super.getBackground());
         scriptureTXA.setBackground(super.getBackground());
         observationTXA.setBackground(super.getBackground());
         applicationTXA.setBackground(super.getBackground());
         prayerTXA.setBackground(super.getBackground());
         titleTXF.setBorder(BorderFactory.createEmptyBorder());
         verseTopicTXF.setBorder(BorderFactory.createEmptyBorder());
         dateBTN.setFocusable(false);
         dateBTN.setBorder(new EmptyBorder(0, 0, 0, 0));
         dateBTN.setButtonState(false);

         gb.gridy = 2;
         gb.insets = new Insets(0, 0, 0, 0);
         gb.gridx = 1;
         gb.gridwidth = 4;
         gb.weighty = 100;
         gb.weightx = 100;
         gb.fill = GridBagConstraints.BOTH;
         c.add(dailyItemsSP, gb);

         if(dailyItems.isEmpty()) {
            editMNI.setEnabled(false);
            editBTN.setEnabled(false);
            deleteBTN.setEnabled(false);
            deleteMNI.setEnabled(false);
         } else {
            editMNI.setEnabled(true);
            editBTN.setEnabled(true);
            deleteBTN.setEnabled(true);
            deleteMNI.setEnabled(true);
         }

         newEntryMNI.setEnabled(true);

         //exitMNI.setEnabled(false);
         newBTN.setEnabled(true);

         c.remove(buttonPNL);
         c.repaint();
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @param e DOCUMENT ME!
    */
   public void valueChanged(ListSelectionEvent e) {
      //Ignore extra message
      if(e.getValueIsAdjusting() || (dailyItemsTBL.getSelectedRow() == -1)) {
         return;
      }

      //update selected row
      selectedRow = dailyItemsTBL.getSelectedRow();

      //        if (selectedRow == -1) {
      //            return;
      //        }
      Object[] obj = new Object[dailyItemsTBL.getColumnCount()];

      for(int column = 0; (column < obj.length) && (selectedRow != -1); column++) {
         obj[column] = dailyItemsTBL.getValueAt(selectedRow, column);
      }

      DailyItem tempItem = new DailyItem((Date)obj[0], (String)obj[1], (String)obj[2]);

      currentItemLocation = dailyItems.indexOf(tempItem);

      if(currentItemLocation != -1) {
         currentItem = (DailyItem)dailyItems.elementAt(currentItemLocation);
         verseTopicTXF.setText(currentItem.getTopic());
         dateBTN.setDate(currentItem.getDate());
         titleTXF.setText(currentItem.getTitle());
         scriptureTXA.setText(currentItem.getScripture());
         observationTXA.setText(currentItem.getObservation());
         applicationTXA.setText(currentItem.getApplication());
         prayerTXA.setText(currentItem.getPrayer());
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @param imageName DOCUMENT ME!
    *
    * @return DOCUMENT ME!
    */
   protected static ImageIcon createGeneralIcon(String imageName) {
      String imgLocation = "icons/" + imageName + ".png";
      java.net.URL imageURL = SOAPGUI.class.getResource(imgLocation);

      if(imageURL == null) {
         System.err.println("Resource not found: " + imgLocation);

         return null;
      } else {
         return new ImageIcon(imageURL);
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @author $author$
    * @version $Revision$
    */
   class AboutAction extends AbstractAction {
      public AboutAction(String text, ImageIcon icon, String desc, Integer mnemonic) {
         super(text, icon);
         putValue(SHORT_DESCRIPTION, desc);
         putValue(MNEMONIC_KEY, mnemonic);
      }

      /**
       * DOCUMENT ME!
       *
       * @param e DOCUMENT ME!
       */
      public void actionPerformed(ActionEvent e) {
         new About();
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @author $author$
    * @version $Revision$
    */
   class DailyReadingAction extends AbstractAction {
      public DailyReadingAction(String text, ImageIcon icon, String desc,
         Integer mnemonic) {
         super(text, icon);
         putValue(SHORT_DESCRIPTION, desc);
         putValue(MNEMONIC_KEY, mnemonic);
      }

      /**
       * DOCUMENT ME!
       *
       * @param e DOCUMENT ME!
       */
      public void actionPerformed(ActionEvent e) {
         new DailyReading(SOAPGUI.this, storage);
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @author $author$
    * @version $Revision$
    */
   class DeleteAction extends AbstractAction {
      public DeleteAction(String text, ImageIcon icon, String desc, Integer mnemonic) {
         super(text, icon);
         putValue(SHORT_DESCRIPTION, desc);
         putValue(MNEMONIC_KEY, mnemonic);
      }

      //the correct thing is in the vector but the wrong element from the table is being deleted
      public void actionPerformed(ActionEvent e) {
         //remove element from vector
         dailyItems.removeElementAt(currentItemLocation);

         //remove the row from the table, and notifies all listeners
         tableMDL.removeRow(sorter.modelIndex(selectedRow));

         //change selected item
         if(selectedRow > 0) {
            rowSM.setSelectionInterval(selectedRow - 1, selectedRow - 1);
         } else if((selectedRow == 0) && (dailyItems.size() > 0)) {
            rowSM.setSelectionInterval(selectedRow, selectedRow);
         }

         //disable edit button
         if(dailyItems.isEmpty()) {
            editMNI.setEnabled(false);
            editBTN.setEnabled(false);
            deleteBTN.setEnabled(false);
            deleteMNI.setEnabled(false);
         }
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @author $author$
    * @version $Revision$
    */
   class EditAction extends AbstractAction {
      public EditAction(String text, ImageIcon icon, String desc, Integer mnemonic) {
         super(text, icon);
         putValue(SHORT_DESCRIPTION, desc);
         putValue(MNEMONIC_KEY, mnemonic);
      }

      /**
       * DOCUMENT ME!
       *
       * @param e DOCUMENT ME!
       */
      public void actionPerformed(ActionEvent e) {
         edit(true);
      }
   }

   ///////////////////////////////////////////////////////////////////////////////
   // ACTIONS
   ///////////////////////////////////////////////////////////////////////////////
   class ExitAction extends AbstractAction {
      public ExitAction(String text, ImageIcon icon, String desc, Integer mnemonic) {
         super(text, icon);
         putValue(SHORT_DESCRIPTION, desc);
         putValue(MNEMONIC_KEY, mnemonic);
      }

      /**
       * The actions that take place when exiting the application. It currently saves
       * the data and exits.
       *
       * @param evt DOCUMENT ME!
       */
      public void actionPerformed(ActionEvent evt) {
         //update data in storage and write to file.
         try {
            storage.setDIData(dailyItems);
            storage.writeToFile();
         } catch(Exception e) {
            JOptionPane.showMessageDialog(SOAPGUI.this,
               "Could not access the database! " +
               "Make sure the database exists and has read/write permission.");
         }

         dispose();
         System.exit(0);
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @author $author$
    * @version $Revision$
    */
   class NewAction extends AbstractAction {
      public NewAction(String text, ImageIcon icon, String desc, Integer mnemonic) {
         super(text, icon);
         putValue(SHORT_DESCRIPTION, desc);
         putValue(MNEMONIC_KEY, mnemonic);
      }

      /**
       * DOCUMENT ME!
       *
       * @param e DOCUMENT ME!
       */
      public void actionPerformed(ActionEvent e) {
         verseTopicTXF.setText("");
         dateBTN.setDate(new Date());
         titleTXF.setText("Title");
         scriptureTXA.setText("");
         observationTXA.setText("");
         applicationTXA.setText("");
         prayerTXA.setText("");
         newEdit = true;
         edit(true);
      }
   }

   /**
    * DOCUMENT ME!
    *
    * @author $author$
    * @version $Revision$
    */
   class PrayerLogAction extends AbstractAction {
      public PrayerLogAction(String text, ImageIcon icon, String desc, Integer mnemonic) {
         super(text, icon);
         putValue(SHORT_DESCRIPTION, desc);
         putValue(MNEMONIC_KEY, mnemonic);
      }

      /**
       * DOCUMENT ME!
       *
       * @param e DOCUMENT ME!
       */
      public void actionPerformed(ActionEvent e) {
         new PrayerLog(storage);
      }
   }
}

//FIXME: a little help section
/*
 * - program to keep daily soap -store/retrieve data in a text file put this in
 * its own class so it can be upgraded later -open from file menu retrieves data
 * -write to file changes on close or save from file menu GUI - table containing -
 * date - scripture/topic - title - date upper right - non editable unless edit
 * is clicked - title top center - non editable unless edit is clicked - content
 * bottom center - non editable unless edit is clicked - buttons - edit & close
 * DailyItem - an object storing the date, scripture/topic, title & content
 */
